﻿' 使用上の注意 ---------------------------------------------------------------
' マイドキュメントに「BackGround.txt」というファイル名で進捗状況を保存します。
' ----------------------------------------------------------------------------

Public Class Form1
    ' マイドキュメントに保存するファイル名
    Const FILENAME As String = "BackGround.txt"

    ' フォームのロード処理
    Private Sub Form1_Load(ByVal sender As Object, _
                           ByVal e As System.EventArgs) Handles Me.Load
        SplitContainer1.Panel2Collapsed = True
        BackgroundWorker1.WorkerReportsProgress = True
        BackgroundWorker1.WorkerSupportsCancellation = True
    End Sub

    ' 非同期で実行ボタンの押下処理
    Private Sub Button1_Click(ByVal sender As System.Object, _
                              ByVal e As System.EventArgs) Handles Button1.Click
        If BackgroundWorker1.IsBusy Then
            MessageBox.Show("実行中です。", "非同期で実行")
        Else
            ProgressBar1.Value = 0
            TextBox2.Text = "処理を開始しました。" & vbCrLf & _
                            "以下のデータを保存しています。" & vbCrLf
            SplitContainer1.Panel2Collapsed = False
            BackgroundWorker1.RunWorkerAsync(10)
        End If
    End Sub

    ' 非同期の実行処理
    Private Sub BackgroundWorker1_DoWork(ByVal sender As System.Object, _
                        ByVal e As System.ComponentModel.DoWorkEventArgs) _
                    Handles BackgroundWorker1.DoWork
        Dim worker As System.ComponentModel.BackgroundWorker = _
                    CType(sender, System.ComponentModel.BackgroundWorker)
        Dim maxCount As Integer = Int(e.Argument)
        Dim sw As System.IO.StreamWriter = Nothing
        Try
            Dim myDocument As String = _
                        My.Computer.FileSystem.SpecialDirectories.MyDocuments
            Dim shiftJIS As System.Text.Encoding = System.Text.Encoding.GetEncoding("Shift_JIS")
            sw = New System.IO.StreamWriter(myDocument & "\" & FILENAME, False, shiftJIS)
            For i As Integer = 1 To maxCount
                Dim data As String = "書き込み時刻：" & Date.Now.ToString("yyyy/MM/dd HH:mm:ss.ff")
                sw.WriteLine(data)
                Threading.Thread.Sleep(1000)
                worker.ReportProgress(100 * i / maxCount, data)

                If worker.CancellationPending Then
                    e.Cancel = True
                    Exit Sub
                End If
            Next
            e.Result = "保存した行数は" & maxCount.ToString() & "行です。"
        Finally
            If sw IsNot Nothing Then
                sw.Close()
                sw.Dispose()
            End If
        End Try
    End Sub

    ' 非同期の進捗度確認処理
    Private Sub BackgroundWorker1_ProgressChanged(ByVal sender As Object, _
                        ByVal e As System.ComponentModel.ProgressChangedEventArgs) _
                    Handles BackgroundWorker1.ProgressChanged
        TextBox2.Text &= vbCrLf & e.UserState.ToString()
        ProgressBar1.Value = e.ProgressPercentage
    End Sub

    ' 非同期の完了処理
    Private Sub BackgroundWorker1_RunWorkerCompleted(ByVal sender As Object, _
                        ByVal e As System.ComponentModel.RunWorkerCompletedEventArgs) _
                    Handles BackgroundWorker1.RunWorkerCompleted
        Dim msg As String = ""
        If e.Cancelled Then
            msg = "処理をキャンセルしました。"
        Else
            If e.Error IsNot Nothing Then
                msg = "エラーが発生しました。" & e.Error.Message
            Else
                msg = "処理を完了しました。" & e.Result.ToString()
            End If
        End If
        TextBox2.Text &= vbCrLf & msg
        MessageBox.Show(msg, "非同期で実行")
        SplitContainer1.Panel2Collapsed = True
    End Sub

    ' 中断ボタンの押下処理
    Private Sub Button2_Click(ByVal sender As System.Object, _
                              ByVal e As System.EventArgs) Handles Button2.Click
        BackgroundWorker1.CancelAsync()
    End Sub
End Class
